﻿//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;
//using System.Threading.Tasks;
using CPrompt;
using System;
using System.Threading;
using UnityEngine;

namespace UH
{
    class Main : MonoBehaviour
    {
        static void t1_Tick(object state)
        {
            Main.AP_max();
            Main.selcharHP();
            Main.selcharCor();
        }

        static Timer t1 = new Timer(new TimerCallback(t1_Tick), null, 1000, 1000);


        static void AP_max()
        {
            APlayer aplayer = AGame.Instance.CurrPlayer;
            aplayer.ResetActionPoints();
            aplayer.RefreshDisplay();
        }

        private void max_resource()
        {
            AGame agame = AGame.Instance;
            AGameData component = AGame.Instance.GetComponent<AGameData>();
            float addf = 100;
            component.SetBaseValue(AGame.cResInfluence, addf + component.GetFloatValue(AGame.cResInfluence, 0f), true);
            component.SetBaseValue(AGame.cResLore, addf + component.GetFloatValue(AGame.cResLore, 0f), true);
            component.SetBaseValue(AGame.cResGold, addf + component.GetFloatValue(AGame.cResGold, 0f), true);
            component.SetBaseValue(AGame.cResFate, addf + component.GetFloatValue(AGame.cResFate, 0f), true);
            component.SetBaseValue(AGame.cResRumors, addf + component.GetFloatValue(AGame.cResRumors, 0f), true);
            AGame.Instance.CurrPlayer.RefreshDisplay();
        }

        static void selcharCor()
        {
            AUIManager am = AUIManager.Instance;
            AEntityCharacter ac = am.SelectedCharacter;
            AGameData component = ac.GetComponent<AGameData>();
            //if (component.HasKey("IsPlayer", true))
            {
                component.SetBaseValue(ACorruptionManager.cStatCorruption, 0f, true);
                AGame.Instance.CurrPlayer.RefreshDisplay();
            }
        }

        static void selcharHP()
        {
            AUIManager am = AUIManager.Instance;
            AEntityCharacter ac = am.SelectedCharacter;
            AGameData component = ac.GetComponent<AGameData>();
            //if (component.HasKey("IsPlayer", true)) 
            { 
                component.SetBaseValue(AEntityCharacter.cStatHealth, component.GetFloatValue(AEntityCharacter.cStatHealth + "Max", 0f), true);
                AGame.Instance.CurrPlayer.RefreshDisplay();
            }
        }

        private void selchar()
        {
            float addf = 10;
            AUIManager am = AUIManager.Instance;
            AEntityCharacter ac = am.SelectedCharacter;
            AGameData component = ac.GetComponent<AGameData>();
            component.SetBaseValue(AGame.cStatSkillArcane, addf + component.GetFloatValue(AGame.cStatSkillArcane, 0f), true);
            component.SetBaseValue(AGame.cStatSkillSocial, addf + component.GetFloatValue(AGame.cStatSkillSocial, 0f), true);
            component.SetBaseValue(AGame.cStatSkillPhysical, addf + component.GetFloatValue(AGame.cStatSkillPhysical, 0f), true);
            component.SetBaseValue(ACorruptionManager.cStatCorruptionResist, addf + component.GetFloatValue(ACorruptionManager.cStatCorruptionResist, 0f), true);
            AGame.Instance.CurrPlayer.RefreshDisplay();
        }



        public void Start()
        {  
        }
        public void Update()
        {
            if (Input.GetKeyDown(KeyCode.KeypadPlus))
            {
                max_resource();
            }
            else if (Input.GetKeyDown(KeyCode.Keypad7))
            {
                selchar();
            }
            else if (Input.GetKeyDown(KeyCode.KeypadMinus))
            {
                AP_max();
            }
            else if (Input.GetKeyDown(KeyCode.Keypad8))
            {
                selcharHP();
            }
            else if (Input.GetKeyDown(KeyCode.Keypad9))
            {
                selcharCor();
            }
            else if (Input.GetKeyDown(KeyCode.Delete))
            {
                Loader.Unload();
            }

        }
        public void OnGUI()
        {
            //GUI.Label(new Rect(Screen.width / 2, Screen.height / 2, 150f, 50f), "GAME INJECTED"); // Should work and when injected you will see this text in the middle of the screen
        }
    }
}
